//
//      **************************************************************
//       JdeBP C++ Library Routines      General Public Licence v1.00
//          Copyright (c) 1991,1992  Jonathan de Boyne Pollard
//      **************************************************************
//
//  Types used in POSIX.1 calls.
//

/*
 *  Since ANSI places time_t in <time.h> and POSIX.1 complies with that,
 *  programs that look for time_t in <sys\types.h> will need to altered.
 *  We therefore DELIBERATELY do not define time_t here.
 */

#if !defined(__STDDEF_H_INCLUDED)
#include <_stddef.h>
#endif

#ifndef _DEV_T_DEFINED
typedef _Dev_t dev_t;
#define _DEV_T_DEFINED
#endif

#ifndef _GID_T_DEFINED
typedef _Gid_t gid_t;
#define _GID_T_DEFINED
#endif

#ifndef _INO_T_DEFINED
typedef _Ino_t ino_t;
#define _INO_T_DEFINED
#endif

#ifndef _MODE_T_DEFINED
typedef _Mode_t mode_t;
#define _MODE_T_DEFINED
#endif

#ifndef _NLINK_T_DEFINED
typedef _Nlink_t nlink_t;
#define _NLINK_T_DEFINED
#endif

#ifndef _OFF_T_DEFINED
typedef _Off_t off_t;       // Must be signed to allow backwards movement
#define _OFF_T_DEFINED
#endif

#ifndef _PID_T_DEFINED
typedef _Pid_t pid_t;       // Must be signed to allow -1 return
#define _PID_T_DEFINED
#endif

#ifndef _SIZE_T_DEFINED
typedef _Size_t size_t;
#define _SIZE_T_DEFINED
#endif

#ifndef _SSIZE_T_DEFINED
typedef _Ssize_t ssize_t;
#define _SSIZE_T_DEFINED
#endif

#ifndef _UID_T_DEFINED
typedef _Uid_t uid_t;
#define _UID_T_DEFINED
#endif
